Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zflx.F90	(revision 6534)
@@ -39,4 +39,7 @@
    !                               !!** Namelist  nampisext  **
    REAL(wp)          ::  atcco2     !: pre-industrial atmospheric [co2] (ppm) 	
+#ifdef key_c13
+   REAL(wp)          ::  d13c_co2   !: d13c of atmospheric [co2] (ppm)   
+#endif
    LOGICAL           ::  ln_co2int  !: flag to read in a file and interpolate atmospheric pco2 or not
    CHARACTER(len=34) ::  clname     !: filename of pco2 values
@@ -55,4 +58,7 @@
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: oce_co2   !: ocean carbon flux 
+#if defined key_c13
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: oce_c13  !: ocean C13 flux
+#endif
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) :: satmco2   !: atmospheric pco2 
 
@@ -84,15 +90,23 @@
       !
       INTEGER  ::   ji, jj, jm, iind, iindm1
-      REAL(wp) ::   ztc, ztc2, ztc3, ztc4, zws, zkgwan
+      REAL(wp) ::   ztc, ztc2, ztc3, zws, zkgwan
       REAL(wp) ::   zfld, zflu, zfld16, zflu16, zfact
       REAL(wp) ::   zph, zah2, zbot, zdic, zalk, zsch_o2, zalka, zsch_co2
       REAL(wp) ::   zyr_dec, zdco2dt
       CHARACTER (len=25) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:) :: zkgco2, zkgo2, zh2co3, zoflx, zw2d 
+      REAL(wp), POINTER, DIMENSION(:,:) :: zkgco2, zkgo2, zh2co3, z_co3, zoflx, zw2d 
+#ifdef key_c13
+      REAL(wp) ::   zft, zfco3
+      REAL(wp), POINTER, DIMENSION(:,:) :: za_dic, za_g
+#endif
       !!---------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('p4z_flx')
       !
-      CALL wrk_alloc( jpi, jpj, zkgco2, zkgo2, zh2co3, zoflx )
+#ifdef key_c13 
+      CALL wrk_alloc( jpi, jpj, zkgco2, zkgo2, zh2co3, z_co3, zoflx,  za_dic, za_g )
+#else
+      CALL wrk_alloc( jpi, jpj, zkgco2, zkgo2, zh2co3, z_co3, zoflx )
+#endif
       !
 
@@ -133,4 +147,7 @@
                zph   = MAX( hi(ji,jj,1), 1.e-10 ) / zfact
                zalka = trb(ji,jj,1,jptal) / zfact
+
+               ! CALCULATE [ALK]([CO3--], [HCO3-])
+               zalk  = zalka - (  akw3(ji,jj,1) / zph - zph + zbot / ( 1.+ zph / akb3(ji,jj,1) )  )
 
                ! CALCULATE [ALK]([CO3--], [HCO3-])
@@ -178,4 +195,13 @@
             zkgco2(ji,jj) = zkgwan * SQRT( 660./ zsch_co2 )
             zkgo2 (ji,jj) = zkgwan * SQRT( 660./ zsch_o2 )
+#if defined key_c13
+            ! Compute fractionation factors for C13 from Zhang et al. 1995
+            zfco3 = MAX(0.05,(z_co3(ji,jj)/trb(ji,jj,1,jpdic)+rtrn))
+            zfco3 = MIN(0.2 , zfco3)
+            zft = MIN( 25., ztc )
+            zft = MAX(  5., zft )
+            za_g  (ji,jj) = 1. + ( -0.0049 * zft - 1.31 ) / 1000.
+            za_dic(ji,jj) = 1. + ( 0.014 * zft * zfco3  - 0.105 * zft + 10.53 ) / 1000.
+#endif
          END DO
       END DO
@@ -183,5 +209,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            ! Compute CO2 flux for the sea and air
+             ! Compute CO2 flux for the sea and air
             zfld = satmco2(ji,jj) * patm(ji,jj) * tmask(ji,jj,1) * chemc(ji,jj) * zkgco2(ji,jj)   ! (mol/L) * (m/s)
             zflu = zh2co3(ji,jj) * tmask(ji,jj,1) * zkgco2(ji,jj)                                   ! (mol/L) (m/s) ?
@@ -195,4 +221,15 @@
             zoflx(ji,jj) = zfld16 - zflu16
             tra(ji,jj,1,jpoxy) = tra(ji,jj,1,jpoxy) + zoflx(ji,jj) * rfact2 / fse3t(ji,jj,1)
+#if defined key_c13
+            tra(ji,jj,1,jp13dic) = tra(ji,jj,1,jp13dic) + ( zfld * (1 + d13c_co2 / 1000.) &
+                                         - zflu * trb(ji,jj,1,jp13dic) / ( trb(ji,jj,1,jpdic) + rtrn ) &
+                                       / ( za_dic(ji,jj) + rtrn) ) &
+                                         * 0.99919 * za_g(ji,jj) * rfact2 / fse3t(ji,jj,1)
+
+             oce_c13(ji,jj) = ( zfld * (1 + d13c_co2 / 1000.) &
+                              - zflu * trb(ji,jj,1,jp13dic) / ( trb(ji,jj,1,jpdic) + rtrn ) &
+                                 / ( za_dic(ji,jj) + rtrn) ) &
+                                 * 0.99919 * za_g(ji,jj)  * rfact2 * e1e2t(ji,jj) * tmask(ji,jj,1) * 1000.
+#endif
          END DO
       END DO
@@ -215,4 +252,11 @@
             CALL iom_put( "Cflx"     , zw2d ) 
          ENDIF
+#if defined key_c13
+         CALL wrk_alloc( jpi, jpj, zw2d )
+         IF( iom_use( "C13flx"  ) )  THEN
+            zw2d(:,:) = oce_c13(:,:) / e1e2t(:,:) * rfact2r
+            CALL iom_put( "C13flx"     , zw2d )
+         ENDIF
+#endif
          IF( iom_use( "Oflx"  ) )  THEN
             zw2d(:,:) =  zoflx(:,:) * 1000 * tmask(:,:,1)
@@ -224,9 +268,9 @@
          ENDIF
          IF( iom_use( "Dpco2" ) ) THEN
-           zw2d(:,:) = ( satmco2(:,:) * patm(:,:) - zh2co3(:,:) / ( chemc(:,:) + rtrn ) ) * tmask(:,:,1)
+           zw2d(:,:) = ( satmco2(:,:) * patm(:,:) - zh2co3(:,:) / ( chemc(:,:,1) + rtrn ) ) * tmask(:,:,1)
            CALL iom_put( "Dpco2" ,  zw2d )
          ENDIF
          IF( iom_use( "Dpo2" ) )  THEN
-           zw2d(:,:) = ( atcox * patm(:,:) - atcox * trn(:,:,1,jpoxy) / ( chemo2(:,:,1) + rtrn ) ) * tmask(:,:,1)
+           zw2d(:,:) = ( atcox * patm(:,:) - trb(:,:,1,jpoxy) / ( chemc(:,:,2) + rtrn ) ) * tmask(:,:,1)
            CALL iom_put( "Dpo2"  , zw2d )
          ENDIF
@@ -240,9 +284,13 @@
             trc2d(:,:,jp_pcs0_2d + 1) = zoflx(:,:) * 1000 * tmask(:,:,1) 
             trc2d(:,:,jp_pcs0_2d + 2) = zkgco2(:,:) * tmask(:,:,1) 
-            trc2d(:,:,jp_pcs0_2d + 3) = ( satmco2(:,:) * patm(:,:) - zh2co3(:,:) / ( chemc(:,:) + rtrn ) ) * tmask(:,:,1) 
-         ENDIF
-      ENDIF
-      !
-      CALL wrk_dealloc( jpi, jpj, zkgco2, zkgo2, zh2co3, zoflx )
+            trc2d(:,:,jp_pcs0_2d + 3) = ( satmco2(:,:) * patm(:,:) - zh2co3(:,:) / ( chemc(:,:,1) + rtrn ) ) * tmask(:,:,1) 
+         ENDIF
+      ENDIF
+      !
+#ifdef key_c13 
+      CALL wrk_dealloc( jpi, jpj, zkgco2, zkgo2, zh2co3, z_co3, zoflx,  za_dic, za_g )
+#else
+      CALL wrk_dealloc( jpi, jpj, zkgco2, zkgo2, zh2co3, z_co3, zoflx )
+#endif
       !
       IF( nn_timing == 1 )  CALL timing_stop('p4z_flx')
@@ -261,5 +309,9 @@
       !! ** input   :   Namelist nampisext
       !!----------------------------------------------------------------------
-      NAMELIST/nampisext/ln_co2int, atcco2, clname, nn_offset
+      NAMELIST/nampisext/ln_co2int, atcco2, &
+#if defined key_c13
+                         &  d13c_co2,       &
+#endif
+                         &  clname, nn_offset
       INTEGER :: jm
       INTEGER :: ios                 ! Local integer output status for namelist read
@@ -286,4 +338,7 @@
          IF(lwp) THEN                         ! control print
             WRITE(numout,*) '    Constant Atmospheric pCO2 value  atcco2    =', atcco2
+#if defined key_c13
+            WRITE(numout,*) '    Constant Atm. d13C of pCO2 value  d13c_co2 =', d13c_co2
+#endif
             WRITE(numout,*) ' '
          ENDIF
@@ -316,4 +371,7 @@
       t_oce_co2_flx = 0._wp
       t_atm_co2_flx = 0._wp
+#ifdef key_c13
+       oce_c13(:,:)  = 0._wp
+#endif
       !
       CALL p4z_patm( nit000 )
@@ -384,5 +442,5 @@
       !!                     ***  ROUTINE p4z_flx_alloc  ***
       !!----------------------------------------------------------------------
-      ALLOCATE( oce_co2(jpi,jpj), satmco2(jpi,jpj), patm(jpi,jpj), STAT=p4z_flx_alloc )
+      ALLOCATE( oce_co2(jpi,jpj), satmco2(jpi,jpj), patm(jpi,jpj), oce_c13(jpi,jpj), STAT=p4z_flx_alloc )
       !
       IF( p4z_flx_alloc /= 0 )   CALL ctl_warn('p4z_flx_alloc : failed to allocate arrays')
@@ -402,3 +460,3 @@
 
    !!======================================================================
-END MODULE p4zflx
+END MODULE  p4zflx
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlim.F90	(revision 6534)
@@ -115,10 +115,10 @@
                ! Michaelis-Menten Limitation term for nutrients Small bacteria
                ! -------------------------------------------------------------
-               zdenom = 1. /  ( concbno3 * concbnh4 + concbnh4 * trb(ji,jj,jk,jpno3) + concbno3 * trb(ji,jj,jk,jpnh4) )
-               xnanono3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * concbnh4 * zdenom
-               xnanonh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * concbno3 * zdenom
+               xnanonh4(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-8 ) / (MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-8 ) + concbnh4)
+               xnanono3(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpno3) - 1.E-8 ) / (MAX(0., trb(ji,jj,jk,jpno3) - 1.E-8 )  &
+                          &                                                  + concbno3) * (1. - xnanonh4(ji,jj,jk) ) 
                !
                zlim1    = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
-               zlim2    = trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + concbnh4 )
+               zlim2    = MAX(0., trb(ji,jj,jk,jppo4) - 1E-9 )/ ( trb(ji,jj,jk,jppo4) + concbnh4 )
                zlim3    = trb(ji,jj,jk,jpfer) / ( concbfe + trb(ji,jj,jk,jpfer) )
                zlim4    = trb(ji,jj,jk,jpdoc) / ( xkdoc   + trb(ji,jj,jk,jpdoc) )
@@ -128,10 +128,10 @@
                ! Michaelis-Menten Limitation term for nutrients Small flagellates
                ! -----------------------------------------------
-               zdenom = 1. /  ( zconc0n * zconc0nnh4 + zconc0nnh4 * trb(ji,jj,jk,jpno3) + zconc0n * trb(ji,jj,jk,jpnh4) )
-               xnanono3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * zconc0nnh4 * zdenom
-               xnanonh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * zconc0n    * zdenom
+               xnanonh4(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-7 ) / (MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-7 ) + zconc0nnh4)
+               xnanono3(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpno3) - 1.E-7 ) / (MAX(0., trb(ji,jj,jk,jpno3) - 1.E-7 )  &
+                          &                      + zconc0n) * (1. - xnanonh4(ji,jj,jk) )   
                !
                zlim1    = xnanono3(ji,jj,jk) + xnanonh4(ji,jj,jk)
-               zlim2    = trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + zconc0nnh4 )
+               zlim2    = MAX(0., trb(ji,jj,jk,jppo4) - 1.E-7 ) / ( trb(ji,jj,jk,jppo4) + zconc0nnh4 )
                zratio   = trb(ji,jj,jk,jpnfe) * z1_trbphy 
                zironmin = xcoef1 * trb(ji,jj,jk,jpnch) * z1_trbphy + xcoef2 * zlim1 + xcoef3 * xnanono3(ji,jj,jk)
@@ -143,10 +143,10 @@
                !   Michaelis-Menten Limitation term for nutrients Diatoms
                !   ----------------------------------------------
-               zdenom   = 1. / ( zconc1d * zconc1dnh4 + zconc1dnh4 * trb(ji,jj,jk,jpno3) + zconc1d * trb(ji,jj,jk,jpnh4) )
-               xdiatno3(ji,jj,jk) = trb(ji,jj,jk,jpno3) * zconc1dnh4 * zdenom
-               xdiatnh4(ji,jj,jk) = trb(ji,jj,jk,jpnh4) * zconc1d    * zdenom
+               xdiatnh4(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-7 ) / (MAX(0., trb(ji,jj,jk,jpnh4) - 1.E-7 ) + zconc1dnh4)
+               xdiatno3(ji,jj,jk) = MAX(0., trb(ji,jj,jk,jpno3) - 1.E-7 ) / (MAX(0., trb(ji,jj,jk,jpno3) - 1.E-7 ) &
+                          &                   + zconc1d ) * (1- xdiatnh4(ji,jj,jk)) 
                !
                zlim1    = xdiatno3(ji,jj,jk) + xdiatnh4(ji,jj,jk)
-               zlim2    = trb(ji,jj,jk,jppo4) / ( trb(ji,jj,jk,jppo4) + zconc1dnh4  )
+               zlim2    = MAX(0., trb(ji,jj,jk,jppo4) - 1.E-7 ) / ( trb(ji,jj,jk,jppo4) + zconc1dnh4  )
                zlim3    = trb(ji,jj,jk,jpsil) / ( trb(ji,jj,jk,jpsil) + xksi(ji,jj) )
                zratio   = trb(ji,jj,jk,jpdfe) * z1_trbdia
@@ -265,3 +265,3 @@
 
    !!======================================================================
-END MODULE p4zlim
+END MODULE  p4zlim
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zlys.F90	(revision 6534)
@@ -142,4 +142,11 @@
               tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) -      zcaldiss(ji,jj,jk)
               tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) +      zcaldiss(ji,jj,jk)
+
+#if defined key_c13
+              zaldi  = zcaldiss(ji,jj,jk) *  trb(ji,jj,jk,jp13cal) / ( trb(ji,jj,jk,jpcal) + rtrn )
+              tra(ji,jj,jk,jp13cal) = tra(ji,jj,jk,jp13cal) - zaldi
+              tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) + zaldi 
+#endif
+
             END DO
          END DO
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmeso.F90	(revision 6534)
@@ -49,4 +49,11 @@
    REAL(wp), PUBLIC ::  epsher2      !: half sturation constant for grazing 2
    REAL(wp), PUBLIC ::  grazflux     !: mesozoo flux feeding rate
+#if defined key_n15
+   REAL(wp), PUBLIC ::  e15n_ex2     !: N15 mesozoo excretion fractionation
+   REAL(wp), PUBLIC ::  e15n_ing2    !: N15 mesozoo ingestion fractionation
+#endif
+#if defined key_c13
+   REAL(wp), PUBLIC ::  e13c_cal2    !: C13 mesozoo calcification fractionation
+#endif
 
    !!* Substitution
@@ -82,4 +89,12 @@
       REAL(wp) :: zgrazn, zgrazpoc, zgraznf, zgrazf
       REAL(wp) :: zgrazfffp, zgrazfffg, zgrazffep, zgrazffeg
+#if defined key_n15
+      REAL(wp) :: zgrazn15,zgrazd15,zgrazpo15,zgrazff15p,zgrazff15g,zgraztot15
+      REAL(wp) :: zgrarem2_15,zgrarsig_15,zgrarsigex_15,zmortzgoc_15,zgrapoc2_15,zfrac15
+#endif
+#if defined key_c13
+      REAL(wp) :: zgrazn13,zgrazd13,zgrazpo13,zgrazff13p,zgrazff13g,zgraztot13
+      REAL(wp) :: zgrarem2_13,zgrarsig_13,zmortzgoc_13,zgrapoc2_13,zfrac13
+#endif
       CHARACTER (len=25) :: charout
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
@@ -139,4 +154,16 @@
                zgrazpof  = zgrazpoc * trb(ji,jj,jk,jpsfe) / ( trb(ji,jj,jk,jppoc) + rtrn)
 
+#ifdef key_n15
+               zgrazn15   = zgrazn   * trb(ji,jj,jk,jp15phy) / ( trb(ji,jj,jk,jpphy) + rtrn)
+               zgrazd15   = zgrazd   * trb(ji,jj,jk,jp15dia) / ( trb(ji,jj,jk,jpdia) + rtrn)
+               zgrazpo15  = zgrazpoc * trb(ji,jj,jk,jp15poc) / ( trb(ji,jj,jk,jppoc) + rtrn)
+#endif
+#ifdef key_c13
+               zgrazn13   = zgrazn   * trb(ji,jj,jk,jp13phy) / ( trb(ji,jj,jk,jpphy) + rtrn)
+               zgrazd13   = zgrazd   * trb(ji,jj,jk,jp13dia) / ( trb(ji,jj,jk,jpdia) + rtrn)
+               zgrazpo13  = zgrazpoc * trb(ji,jj,jk,jp13poc) / ( trb(ji,jj,jk,jppoc) + rtrn)
+#endif
+
+
                !  Mesozooplankton flux feeding on GOC
                !  ----------------------------------
@@ -150,4 +177,13 @@
                &           * tgfunc2(ji,jj,jk) * trb(ji,jj,jk,jppoc) * trb(ji,jj,jk,jpmes)
                zgrazfffp = zgrazffep * trb(ji,jj,jk,jpsfe) / (trb(ji,jj,jk,jppoc) + rtrn)
+#ifdef key_n15
+               zgrazff15g = zgrazffeg * trb(ji,jj,jk,jp15goc) / (trb(ji,jj,jk,jpgoc) + rtrn)
+               zgrazff15p = zgrazffep * trb(ji,jj,jk,jp15poc) / (trb(ji,jj,jk,jppoc) + rtrn)
+#endif
+#ifdef key_c13
+               zgrazff13g = zgrazffeg * trb(ji,jj,jk,jp13goc) / (trb(ji,jj,jk,jpgoc) + rtrn)
+               zgrazff13p = zgrazffep * trb(ji,jj,jk,jp13poc) / (trb(ji,jj,jk,jppoc) + rtrn)
+#endif
+
               !
 # if ! defined key_kriest
@@ -173,4 +209,20 @@
               &   + zgrazpoc + zgrazffep + zgrazffeg
               zgraztotf = zgrazf + zgraznf + zgrazz * ferat3 + zgrazpof + zgrazfffp + zgrazfffg
+
+#ifdef key_n15
+              zfrac15   =  zfrac * trb(ji,jj,jk,jp15goc) / (trb(ji,jj,jk,jpgoc) + rtrn)
+              zgrazff15p = zproport * zgrazff15p
+              zgrazff15g = zproport * zgrazff15g
+              zgraztot15 = zgrazd15 + zgrazn15 + zgrazz * trb(ji,jj,jk,jp15zoo) / (trb(ji,jj,jk,jpzoo) + rtrn)  + zgrazpo15 + zgrazff15p + zgrazff15g
+#endif
+#ifdef key_c13
+              zfrac13   =  zfrac * trb(ji,jj,jk,jp13goc) / (trb(ji,jj,jk,jpgoc) + rtrn)
+              zgrazff13p = zproport * zgrazff13p
+              zgrazff13g = zproport * zgrazff13g
+              zgraztot13 = zgrazd13 + zgrazn13 + zgrazz * trb(ji,jj,jk,jp13zoo) / (trb(ji,jj,jk,jpzoo) + rtrn)  + zgrazpo13 + zgrazff13p + zgrazff13g
+#endif
+
+
+
 # else
               zgraztot  = zgrazd + zgrazz + zgrazn + zgrazpoc + zgrazffep
@@ -198,4 +250,25 @@
                 &       + ferat3 * ( ( 1. - epsher2 - unass2 ) /( 1. - epsher2 ) * ztortz2 )
                zgrapoc2  = zgraztot * unass2
+
+#ifdef key_n15
+               zgrarem2_15  = zgraztot15 * ( 1. - zepsherv - unass2 )            &
+                        + ( 1. - epsher2 - unass2 ) / ( 1. - epsher2 ) * ztortz2 &
+                        * trb(ji,jj,jk,jp15mes) / ( trb(ji,jj,jk,jpmes) + rtrn )
+               zgrarsig_15  = zgrarem2_15 * sigma2
+               zgrarsigex_15  =  zgraztot15 * ( 1. - epsher2 - unass2 ) * sigma2 * zgrasratn
+               zgrapoc2_15  = zgraztot15 * unass2
+               zmortzgoc_15  = ( unass2 / ( 1. - epsher2 ) * ztortz2 + zrespz2 )  &
+                        * trb(ji,jj,jk,jp15mes) / ( trb(ji,jj,jk,jpmes) + rtrn )
+#endif
+#ifdef key_c13
+               zgrarem2_13  = zgraztot13 * ( 1. - zepsherv - unass2 ) &
+                        + ( 1. - epsher2 - unass2 ) / ( 1. - epsher2 ) * ztortz2 &
+                        * trb(ji,jj,jk,jp13mes) / ( trb(ji,jj,jk,jpmes) + rtrn )
+               zgrarsig_13  = zgrarem2_13 * sigma2
+               zgrapoc2_13  = zgraztot13 * unass2
+               zmortzgoc_13  = ( unass2 / ( 1. - epsher2 ) * ztortz2 + zrespz2 ) &
+                        * trb(ji,jj,jk,jp13mes) / ( trb(ji,jj,jk,jpmes) + rtrn )
+#endif
+
 
                !   Update the arrays TRA which contain the biological sources and sinks
@@ -222,4 +295,26 @@
                tra(ji,jj,jk,jpdfe) = tra(ji,jj,jk,jpdfe) - zgrazf
 
+#if defined key_n15
+               tra(ji,jj,jk,jp15nh4) = tra(ji,jj,jk,jp15nh4) + (1. - e15n_ex2 / 1000.) * zgrarsigex_15   &
+               &  + (zgrarsig_15-zgrarsigex_15)
+               tra(ji,jj,jk,jp15doc) = tra(ji,jj,jk,jp15doc) + zgrarem2_15 - zgrarsig_15
+               tra(ji,jj,jk,jp15mes) = tra(ji,jj,jk,jp15mes) - zmortz2 * trb(ji,jj,jk,jp15mes) / (trb(ji,jj,jk,jpmes) + rtrn) &
+                                                             + zepsherv * zgraztot15 &
+                                                             + zgrarsigex_15 * (e15n_ex2 / 1000.) &
+               &                                             + zgrapoc2_15  * (e15n_ing2 / 1000.)
+               tra(ji,jj,jk,jp15dia) = tra(ji,jj,jk,jp15dia) - zgrazd15 
+               tra(ji,jj,jk,jp15zoo) = tra(ji,jj,jk,jp15zoo) - zgrazz * trb(ji,jj,jk,jp15zoo) / ( trb(ji,jj,jk,jpzoo) + rtrn )
+               tra(ji,jj,jk,jp15phy) = tra(ji,jj,jk,jp15phy) - zgrazn15 
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) + zgrarsig_13
+               tra(ji,jj,jk,jp13doc) = tra(ji,jj,jk,jp13doc) + zgrarem2_13 - zgrarsig_13
+               tra(ji,jj,jk,jp13mes) = tra(ji,jj,jk,jp13mes) - zmortz2 * trb(ji,jj,jk,jp13mes) / (trb(ji,jj,jk,jpmes) + rtrn) &
+                                                             + zepsherv * zgraztot13 
+               tra(ji,jj,jk,jp13dia) = tra(ji,jj,jk,jp13dia) - zgrazd13
+               tra(ji,jj,jk,jp13zoo) = tra(ji,jj,jk,jp13zoo) - zgrazz * trb(ji,jj,jk,jp13zoo) / ( trb(ji,jj,jk,jpzoo) + rtrn )
+               tra(ji,jj,jk,jp13phy) = tra(ji,jj,jk,jp13phy) - zgrazn13
+#endif
+
                ! calcite production
                zprcaca = xfracal(ji,jj,jk) * zgrazn
@@ -230,4 +325,11 @@
                tra(ji,jj,jk,jptal) = tra(ji,jj,jk,jptal) - 2. * zprcaca
                tra(ji,jj,jk,jpcal) = tra(ji,jj,jk,jpcal) + zprcaca
+#if defined key_c13
+               tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) - zprcaca *  ( 1.  - e13c_cal2/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) )
+               tra(ji,jj,jk,jp13cal) = tra(ji,jj,jk,jp13cal) + zprcaca *  ( 1.  - e13c_cal2/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) )
+#endif
+
 #if defined key_kriest
               znumpoc = trb(ji,jj,jk,jpnum) / ( trb(ji,jj,jk,jppoc) + rtrn )
@@ -243,4 +345,13 @@
               tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + ferat3 * zmortzgoc - zgrazfffg     &
                  &                + zgraztotf * unass2 - zfracfe
+#if defined key_n15
+              tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) - zgrazpo15 - zgrazff15p + zfrac15
+              tra(ji,jj,jk,jp15goc) = tra(ji,jj,jk,jp15goc) + zmortzgoc_15 - zgrazff15g       &
+                 &    + (1. - e15n_ing2/1000.) * zgrapoc2_15 - zfrac15
+#endif
+#if defined key_c13
+              tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) - zgrazpo13 - zgrazff13p + zfrac13
+              tra(ji,jj,jk,jp13goc) = tra(ji,jj,jk,jp13goc) + zmortzgoc_13 - zgrazff13g + zgrapoc2_13 - zfrac13
+#endif
 #endif
             END DO
@@ -289,5 +400,12 @@
       NAMELIST/nampismes/ part2, grazrat2, resrat2, mzrat2, xprefc, xprefp, xprefz,   &
          &                xprefpoc, xthresh2dia, xthresh2phy, xthresh2zoo, xthresh2poc, &
+#if defined key_n15
+         &                e15n_ex2, e15n_ing2,   &
+#endif
+#if defined key_c13
+         &                e13c_cal2,  &
+#endif
          &                xthresh2, xkgraz2, epsher2, sigma2, unass2, grazflux
+
       INTEGER :: ios                 ! Local integer output status for namelist read
 
@@ -324,4 +442,11 @@
          WRITE(numout,*) '    Fraction of mesozoo excretion as DOM           sigma2       =', sigma2
          WRITE(numout,*) '    half sturation constant for grazing 2          xkgraz2      =', xkgraz2
+#if defined key_n15
+         WRITE(numout,*) '    N15 mesozoo excretion fractionation            e15n_ex2     =', e15n_ex2
+         WRITE(numout,*) '    N15 mesozoo ingestion fractionation            e15n_ing2    =', e15n_ing2
+#endif
+#if defined key_c13
+         WRITE(numout,*) '    C13 mesozoo calcification fractionation        e13c_cal2    =', e13c_cal2
+#endif
       ENDIF
 
@@ -340,3 +465,3 @@
 
    !!======================================================================
-END MODULE p4zmeso
+END MODULE  p4zmeso
Index: /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90	(revision 6533)
+++ /branches/CNRS/dev_r6526_PISCES_ISO/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zmicro.F90	(revision 6534)
@@ -47,5 +47,11 @@
    REAL(wp), PUBLIC ::  sigma1      !: Fraction of microzoo excretion as DOM 
    REAL(wp), PUBLIC ::  epsher      !: half sturation constant for grazing 1 
-
+#if defined key_n15
+   REAL(wp), PUBLIC ::  e15n_ex     !: N15 microzoo excretion fractionation
+   REAL(wp), PUBLIC ::  e15n_ing     !: N15 microzoo ingestion fractionation
+#endif
+#if defined key_c13
+   REAL(wp), PUBLIC ::  e13c_calz   !: C13 microzoo calcification fractionation
+#endif
 
    !!* Substitution
@@ -79,4 +85,12 @@
       REAL(wp) :: zgrazp, zgrazm, zgrazsd
       REAL(wp) :: zgrazmf, zgrazsf, zgrazpf
+#if defined key_n15
+      REAL(wp) :: zgrazp15,zgrazm15,zgrazs15,zgraztot15
+      REAL(wp) :: zgrarem_15,zgrarsig_15,zgrarsigex_15,zmortz_15,zgrapoc_15
+#endif
+#if defined key_c13
+      REAL(wp) :: zgrazp13,zgrazm13,zgrazs13,zgraztot13
+      REAL(wp) :: zgrarem_13,zgrarsig_13,zmortz_13,zgrapoc_13
+#endif
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zgrazing, zw3d
       CHARACTER (len=25) :: charout
@@ -126,8 +140,22 @@
                zgrazmf   = zgrazm  * trb(ji,jj,jk,jpsfe) / (trb(ji,jj,jk,jppoc) + rtrn)
                zgrazsf   = zgrazsd * trb(ji,jj,jk,jpdfe) / (trb(ji,jj,jk,jpdia) + rtrn)
+
                !
                zgraztot  = zgrazp  + zgrazm  + zgrazsd 
                zgraztotf = zgrazpf + zgrazsf + zgrazmf 
                zgraztotn = zgrazp * quotan(ji,jj,jk) + zgrazm + zgrazsd * quotad(ji,jj,jk)
+               !
+#ifdef key_n15
+               zgrazp15   = zgrazp   * trb(ji,jj,jk,jp15phy) / ( trb(ji,jj,jk,jpphy) + rtrn)
+               zgrazm15   = zgrazm   * trb(ji,jj,jk,jp15poc) / ( trb(ji,jj,jk,jppoc) + rtrn)
+               zgrazs15  =  zgrazsd  * trb(ji,jj,jk,jp15dia) / ( trb(ji,jj,jk,jpdia) + rtrn)
+               zgraztot15 = zgrazp15 + zgrazm15 + zgrazs15
+#endif
+#ifdef key_c13
+               zgrazp13   = zgrazp   * trb(ji,jj,jk,jp13phy) / ( trb(ji,jj,jk,jpphy) + rtrn)
+               zgrazm13   = zgrazm   * trb(ji,jj,jk,jp13poc) / ( trb(ji,jj,jk,jppoc) + rtrn)
+               zgrazs13  =  zgrazsd  * trb(ji,jj,jk,jp13dia) / ( trb(ji,jj,jk,jpdia) + rtrn)
+               zgraztot13 = zgrazp13 + zgrazm13 + zgrazs13
+#endif
 
                ! Grazing by microzooplankton
@@ -143,4 +171,19 @@
                zgrarem   = zgraztot * ( 1. - zepsherv - unass )
                zgrapoc   = zgraztot * unass
+
+#ifdef key_n15
+               zgrarem_15   = zgraztot15 * ( 1. - zepsherv - unass )
+               zgrapoc_15   = zgraztot15 * unass
+               zgrarsig_15  = zgrarem_15 * sigma1
+               zgrarsigex_15 = (1. - epsher - unass ) * zgraztot15 * sigma1 * zgrasratn
+               zmortz_15 = (ztortz + zrespz) * trb(ji,jj,jk,jp15zoo) / ( trb(ji,jj,jk,jpzoo) + rtrn )
+#endif
+#ifdef key_c13
+               zgrarem_13   = zgraztot13 * ( 1. - zepsherv - unass )
+               zgrapoc_13   = zgraztot13 * unass
+               zgrarsig_13  = zgrarem_13 * sigma1
+               zmortz_13 = (ztortz + zrespz) * trb(ji,jj,jk,jp13zoo) / ( trb(ji,jj,jk,jpzoo) + rtrn )
+#endif
+
 
                !  Update of the TRA arrays
@@ -159,4 +202,18 @@
                tra(ji,jj,jk,jpnum) = tra(ji,jj,jk,jpnum) + zgrapoc * xkr_dmicro
 #endif
+               !
+#if defined key_n15
+               tra(ji,jj,jk,jp15nh4) = tra(ji,jj,jk,jp15nh4) + (1. - e15n_ex / 1000.) * zgrarsigex_15   &
+               &   + (zgrarsig_15-zgrarsigex_15)
+               tra(ji,jj,jk,jp15doc) = tra(ji,jj,jk,jp15doc) + zgrarem_15 - zgrarsig_15
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) + (1. - e15n_ing / 1000.) * zgrapoc_15
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) + zgrarsig_13
+               tra(ji,jj,jk,jp13doc) = tra(ji,jj,jk,jp13doc) + zgrarem_13 - zgrarsig_13
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) + zgrapoc_13
+#endif
+
+               !
                !   Update the arrays TRA which contain the biological sources and sinks
                !   --------------------------------------------------------------------
@@ -186,4 +243,24 @@
                                                          - zgrazm * trb(ji,jj,jk,jpnum) / ( trb(ji,jj,jk,jppoc) + rtrn )
 #endif
+               !
+#if defined key_n15
+               tra(ji,jj,jk,jp15zoo) = tra(ji,jj,jk,jp15zoo) - zmortz_15 + zepsherv * zgraztot15    &
+               &                       + e15n_ex / 1000. * zgrarsigex_15 + e15n_ing / 1000. * zgrapoc_15
+               tra(ji,jj,jk,jp15phy) = tra(ji,jj,jk,jp15phy) - zgrazp15
+               tra(ji,jj,jk,jp15dia) = tra(ji,jj,jk,jp15dia) - zgrazs15
+               tra(ji,jj,jk,jp15poc) = tra(ji,jj,jk,jp15poc) + zmortz_15 - zgrazm15
+#endif
+#if defined key_c13
+               tra(ji,jj,jk,jp13zoo) = tra(ji,jj,jk,jp13zoo) - zmortz_13 + zepsherv * zgraztot13
+               tra(ji,jj,jk,jp13phy) = tra(ji,jj,jk,jp13phy) - zgrazp13
+               tra(ji,jj,jk,jp13dia) = tra(ji,jj,jk,jp13dia) - zgrazs13
+               tra(ji,jj,jk,jp13poc) = tra(ji,jj,jk,jp13poc) + zmortz_13 - zgrazm13
+
+               tra(ji,jj,jk,jp13dic) = tra(ji,jj,jk,jp13dic) - zprcaca *  ( 1.  - e13c_calz/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) )
+               tra(ji,jj,jk,jp13cal) = tra(ji,jj,jk,jp13cal) + zprcaca *  ( 1.  - e13c_calz/1000. ) &
+                                                  * ( trb(ji,jj,jk,jp13dic) / (trb(ji,jj,jk,jpdic) + rtrn ) )
+#endif
+
             END DO
          END DO
@@ -228,4 +305,10 @@
       NAMELIST/nampiszoo/ part, grazrat, resrat, mzrat, xpref2c, xpref2p, &
          &                xpref2d,  xthreshdia,  xthreshphy,  xthreshpoc, &
+#ifdef key_n15
+         &                e15n_ex, e15n_ing,   &
+#endif
+#ifdef key_c13
+         &                e13c_calz, &
+#endif
          &                xthresh, xkgraz, epsher, sigma1, unass
       INTEGER :: ios                 ! Local integer output status for namelist read
@@ -259,4 +342,11 @@
          WRITE(numout,*) '    Fraction of microzoo excretion as DOM           sigma1      =', sigma1
          WRITE(numout,*) '    half sturation constant for grazing 1           xkgraz      =', xkgraz
+#if defined key_n15
+         WRITE(numout,*) '    N15 microzoo excretion fractionation            e15n_ex     =', e15n_ex
+         WRITE(numout,*) '    N15 microzoo ingestion fractionation            e15n_ing    =', e15n_ing
+#endif
+#if defined key_c13
+         WRITE(numout,*) '    C13 microzoo calcification fractionation        e13c_calz   =', e13c_calz
+#endif
       ENDIF
 
@@ -273,3 +363,3 @@
 
    !!======================================================================
-END MODULE p4zmicro
+END MODULE  p4zmicro
